//the following six shaders are modified versions of a shader supplied by ydnar--HUGE thanks!
//some explanation: tcGen vector (<sx> <sy> <sz>) (<tx> <ty> <tz>) 

//New texcoord generation by world projection. This allows you to project a texture onto a surface in a fixed
//way, regardless of its orientation. S coordinates correspond to the "x" coordinates on the texture itself.
//T coordinates correspond to the "y" coordinates on the texture itself. The measurements are in game units.

//Example: tcGen vector (0.01 0 0) (0 0.01 0)
//This would project a texture with a repeat every 100 units across the X/Y plane.

//they include a version of id's original pjrock17 with different hue and saturation to better match the skybox
//and light combination, and versions of rock textures from Kat with similar changes

textures/pjw3dm4/pjw_rock_ZX
{
 	qer_editorimage textures/pjw3dm4/pjwZXproj.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0.015 0 0 ) ( 0 0 0.015 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0.0011 0 0 ) ( 0 0 0.0011 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		//tcMod scale 2 2
		detail
	}
}

textures/pjw3dm4/pjw_rock_ZY
{
 	qer_editorimage textures/pjw3dm4/pjwZYproj.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0 0.015 0 ) ( 0 0 0.015 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0 0.0011 0 ) ( 0 0 0.0011 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		//tcMod scale 2 2
		detail
	}
}

textures/pjw3dm4/pjw_rock_XY
{
 	qer_editorimage textures/pjw3dm4/pjwXYproj.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0 0.015 0 ) ( 0.015 0 0 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0 0.0011 0 ) ( 0.0011 0 0 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcMod scale 2 2
		//detail
	}
}

textures/pjw3dm4/pjw_rock_ZX_bw
{
 	qer_editorimage textures/pjw3dm4/pjwZXproj_bw.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2_bw.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0.015 0 0 ) ( 0 0 0.015 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0.0011 0 0 ) ( 0 0 0.0011 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		//tcMod scale 2 2
		detail
	}
}

textures/pjw3dm4/pjw_rock_ZY_bw
{
 	qer_editorimage textures/pjw3dm4/pjwZYproj_bw.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2_bw.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0 0.015 0 ) ( 0 0 0.015 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0 0.0011 0 ) ( 0 0 0.0011 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		//tcMod scale 2 2
		detail
	}
}

textures/pjw3dm4/pjw_rock_XY_bw
{
 	qer_editorimage textures/pjw3dm4/pjwXYproj_bw.tga
	{
		map $lightmap
		rgbGen identity
	}
	{
		map textures/pjw3dm4/kt_rock_1c_pjw2_bw.tga
		blendFunc GL_DST_COLOR GL_ZERO
		rgbGen identity
		tcGen vector ( 0 0.015 0 ) ( 0.015 0 0 )
	}
	{
		map textures/pjw3dm4/pjrock17_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcGen vector ( 0 0.0011 0 ) ( 0.0011 0 0 )
	}
	{
		map textures/pjw3dm4/kattex-3-stone-bmp_pjw_bw.tga
		blendFunc GL_DST_COLOR GL_SRC_COLOR
		rgbGen identity
		tcMod scale 2 2
		//detail
	}
}



//skybox by the Mighty Pete (thanks Mighty Pete!!)
textures/pjw3dm4/pjw3dm4_mightypetesky
{
 qer_editorimage textures/pjw3dm4/orange.tga
 //qer_editorimage textures/common/white.tga
 surfaceparm noimpact
 surfaceparm nolightmap
 q3map_surfacelight 500
 q3map_sun 1.00 0.70 0.40 700 0 90
 skyparms env/pjw3dm4sky/mercury512 - -
}

//gooishness around the eggclutch
textures/pjw3dm4/pjweggslime
{
 qer_editorimage textures/pjw3dm4/pjw_proto_gruel3.tga
 q3map_lightimage textures/common/white.tga
 q3map_globaltexture
 q3map_lightsubdivide 32
 surfaceparm noimpact
 surfaceparm nolightmap
 surfaceparm water		
 q3map_surfacelight 1300
 {
  map textures/pjw3dm4/pjw_proto_gruel3.tga
  tcMod turb .3 .2 1 .05
  tcMod scroll .01 .01
 }	
 {
 map textures/liquids/pool3d_5e.tga
 blendfunc GL_ONE GL_ONE
 tcMod turb .2 .1 1 .05
 tcMod scale .5 .5
 tcMod scroll .01 .01
 }	
}

//yummy egg skin--from an id shader (removed the trans parm and changed color)
textures/pjw3dm4/pjweggskin
{
 qer_editorimage textures/pjw3dm4/surface8_pjw.tga
 {
  map $lightmap
  rgbGen identity
 }
 {
  map textures/pjw3dm4/surface8_pjw.tga
  rgbGen identity
  blendFunc GL_DST_COLOR GL_ZERO
 }
}


//modified id shader; brightass lava for illumination from little glowy bits
//also changed .jpg to a darker, more reddish hue
textures/pjw3dm4/pjwflatlava_10000
{
 qer_editorimage textures/liquids/proto_grueldark.tga
 q3map_lightimage textures/pjw3dm4/orange.tga
 surfaceparm noimpact
 surfaceparm lava
 //surfaceparm nolightmap
 q3map_surfacelight 4500
 //cull disable
 {
  map $lightmap
  rgbGen identity
 }
 {
  map textures/liquids/proto_grueldark.tga
  rgbGen identity
  tcMod turb 0 .05 0 .03
 }
}

//modified id shader; tweaked lighting, and removed vertex deformation to reduce tris
//also changed texture to better match the skybox
textures/pjw3dm4/pjwflatlava
{
 qer_editorimage textures/liquids/proto_grueldark.tga
 q3map_lightimage textures/pjw3dm4/orange.tga
 surfaceparm noimpact
 surfaceparm lava
 surfaceparm nolightmap
 q3map_surfacelight 400
 {
 map textures/liquids/proto_grueldark.tga
 tcMod turb 0 .2 0 .2
 tcMod scale .3 .3
 }
}

//*very* heavily modifed version of a superclear glass shader from Sir Fubar . . .
textures/pjw3dm4/pjwcrystalblend 
{ 
 qer_editorimage textures/pjw3dm4/pjwcrystalcrap_bright.tga
 q3map_lightimage textures/pjw3dm4/orange.tga
 //surfaceparm nolightmap
 q3map_surfacelight 1400
 {
  map textures/pjw3dm4/pjwcrystalcrap_bright.tga
  rgbGen identity
  tcMod turb 1 .3 0 .05
  tcMod scale .3 .3
 }
 { 
  map textures/base_wall/shiny3.tga 
  blendfunc add 
  rgbGen identity 
  tcGen environment 
 }
 {
  map $lightmap 
  blendfunc filter
  rgbGen identity 
 } 
}

//brighter *very* heavily modifed version of a superclear glass shader from Sir Fubar . . .
textures/pjw3dm4/pjwcrystalbright 
{ 
 qer_editorimage textures/pjw3dm4/pjwcrystalcrap_bright.tga
 //q3map_lightimage textures/pjw3dm4/orange.tga
 //surfaceparm nolightmap
 q3map_surfacelight 3500
 {
  map textures/pjw3dm4/pjwcrystalcrap_bright.tga
  rgbGen identity
  tcMod turb 1 .3 0 .05
  tcMod scale .3 .3
 }
 { 
  map textures/base_wall/shiny3.tga 
  blendfunc add 
  rgbGen identity 
  tcGen environment 
 }
 {
  map $lightmap 
  blendfunc filter
  rgbGen identity 
 } 
}



//sand texture is courtesy of Mr. Clean (thanks Mr. Clean!)
textures/pjw3dm4/sand_02
{
 qer_editorimage textures/pjw3dm4/sand_02.tga
 surfaceparm nosteps
 {
  map $lightmap
  rgbGen identity
 }
 {
  map textures/pjw3dm4/sand_02.tga
  blendFunc GL_DST_COLOR GL_ZERO
  rgbgen identity
 }
}

//this one is from Mr. Clean as well
textures/pjw3dm4/sand_02_bloody
{
 qer_editorimage textures/pjw3dm4/sand_02_bloody.tga
 surfaceparm nosteps
 {
 map $lightmap
 rgbGen identity
 }
 {
 map textures/pjw3dm4/sand_02_bloody.tga
 blendFunc GL_DST_COLOR GL_ZERO
 rgbgen identity
 }
}

//glowy watery crap in cave (made from one of the id liquid shaders)
textures/pjw3dm4/pjw3dm4glowwater
{
 qer_editorimage textures/liquids/pool3d_6e.tga
 q3map_lightimage textures/pjw3dm4/orange.tga
 q3map_globaltexture
 surfaceparm nonsolid
 surfaceparm water
 surfaceparm trans
 //surfaceparm nolightmap
 cull disable
 q3map_surfacelight 400
 { 
  map textures/liquids/pool3d_6e.tga
  rgbgen identity
  tcmod scale 2 2
  tcMod turb 1 .2 0 .03
 }
 {
  map $lightmap
  blendFunc GL_dst_color GL_zero
  rgbgen identity		
 }
}

//not-so glowy watery crap in cave (made from one of the id liquid shaders)
textures/pjw3dm4/pjw3dm4dimwater
{
 qer_editorimage textures/liquids/pool3d_6e.tga
 q3map_lightimage textures/pjw3dm4/orange.tga
 q3map_globaltexture
 surfaceparm nonsolid
 surfaceparm water
 surfaceparm trans
 //surfaceparm nolightmap
 cull disable
 q3map_surfacelight 10
 { 
  map textures/liquids/pool3d_6e.tga
  rgbgen identity
  tcmod scale 2 2
  tcMod turb 1 .2 0 .03
 }
 {
  map $lightmap
  blendFunc GL_dst_color GL_zero
  rgbgen identity		
 }
}


//modified id texture
textures/pjw3dm4/pjwflame
{
	surfaceparm nomarks
	surfaceparm nolightmap
	surfaceparm trans
	cull none
	q3map_surfacelight 8000
	deformvertexes autosprite2
	qer_editorimage textures/sfx/flame1.tga	

	{
		animMap 10 textures/sfx/flame1.tga textures/sfx/flame2.tga textures/sfx/flame3.tga textures/sfx/flame4.tga textures/sfx/flame5.tga textures/sfx/flame6.tga textures/sfx/flame7.tga textures/sfx/flame8.tga
		blendFunc GL_ONE GL_ONE
		rgbGen wave inverseSawtooth 0 1 0 10
		
	}	
	{
		animMap 10 textures/sfx/flame2.tga textures/sfx/flame3.tga textures/sfx/flame4.tga textures/sfx/flame5.tga textures/sfx/flame6.tga textures/sfx/flame7.tga textures/sfx/flame8.tga textures/sfx/flame1.tga
		blendFunc GL_ONE GL_ONE
		rgbGen wave sawtooth 0 1 0 10
	}	


	{
		map textures/sfx/flameball.tga
		blendFunc GL_ONE GL_ONE
		rgbGen wave sin .6 .2 0 .6	
	}

}

//modified id texture
textures/pjw3dm4/pjwhellfogdense
{
	qer_editorimage textures/sfx/fog_red.tga
	surfaceparm	trans
	surfaceparm	nonsolid
	surfaceparm	fog
	surfaceparm 	nodrop
	surfaceparm 	nolightmap
	q3map_globaltexture
	//q3map_surfacelight 100
	fogparms ( .55 .11 .1 ) 256	
	{
		map textures/liquids/kc_fogcloud3.tga
		blendfunc gl_dst_color gl_zero
		tcmod scale -.05 -.05
		tcmod scroll .01 -.01
		rgbgen identity
	}
	{
		map textures/liquids/kc_fogcloud3.tga
		blendfunc gl_dst_color gl_zero
		tcmod scale .05 .05
		tcmod scroll .01 -.01
		rgbgen identity
	}		
}
